diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/boehm-gc/configure.in gcc-3.3.3/boehm-gc/configure.in
--- /usr1/rtems/work-tools/original/gcc-3.3.3/boehm-gc/configure.in	Wed Oct  1 14:06:52 2003
+++ gcc-3.3.3/boehm-gc/configure.in	Thu Feb 26 08:06:25 2004
@@ -113,6 +113,10 @@
 	;;
     esac
     ;;
+ *-*-rtems*)
+    THREADS=posix
+    AC_DEFINE(GC_PTHREADS)
+    ;;
  win32)
     AC_DEFINE(GC_WIN32_THREADS)
     AC_DEFINE(NO_GETENV)
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/arm/arm.h gcc-3.3.3/gcc/config/arm/arm.h
--- /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/arm/arm.h	Fri Nov 15 05:21:36 2002
+++ gcc-3.3.3/gcc/config/arm/arm.h	Thu Mar  4 07:21:52 2004
@@ -1,6 +1,6 @@
 /* Definitions of target machine for GNU compiler, for ARM.
    Copyright (C) 1991, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000,
-   2001, 2002 Free Software Foundation, Inc.
+   2001, 2002, 2004 Free Software Foundation, Inc.
    Contributed by Pieter `Tiggr' Schoenmakers (rcpieter@win.tue.nl)
    and Martin Simmons (@harleqn.co.uk).
    More major hacks by Richard Earnshaw (rearnsha@arm.com)
@@ -2180,6 +2180,7 @@
 	goto WIN;							\
     }									\
   else if (GET_MODE_CLASS (MODE) != MODE_FLOAT				\
+	   && GET_MODE_SIZE (mode) == 4					\
 	   && GET_CODE (X) == SYMBOL_REF				\
 	   && CONSTANT_POOL_ADDRESS_P (X)				\
 	   && ! (flag_pic						\
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/arm/rtems-elf.h gcc-3.3.3/gcc/config/arm/rtems-elf.h
--- /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/arm/rtems-elf.h	Tue May 14 12:35:49 2002
+++ gcc-3.3.3/gcc/config/arm/rtems-elf.h	Thu Feb 26 08:06:25 2004
@@ -30,3 +30,43 @@
 	builtin_define ("__ELF__");		\
 	builtin_assert ("system=rtems");	\
     } while (0)
+
+/* Redefine it to be independent of any defaults */
+#undef TARGET_DEFAULT
+#define TARGET_DEFAULT  (ARM_FLAG_SOFT_FLOAT | ARM_FLAG_APCS_32 | ARM_FLAG_APCS_FRAME)
+
+/* Because TARGET_DEFAULT sets ARM_FLAG_SOFT_FLOAT */
+#undef CPP_FLOAT_DEFAULT_SPEC
+#define CPP_FLOAT_DEFAULT_SPEC "-D__SOFTFP__"
+
+/*
+ * Upward compatibility hacks: 
+ * Once gcc has adopted subtarget_asm_float_spec in arm/elf.h 
+ * the code below needs to be revisited.
+ * Only SUBTARGET_ASM_FLOAT_SPEC should be needed then.
+ */
+#undef ASM_SPEC
+#define ASM_SPEC "\
+%{mbig-endian:-EB} \
+%{mlittle-endian:-EL} \
+%{mcpu=*:-mcpu=%*} \
+%{march=*:-march=%*} \
+%{mapcs-*:-mapcs-%*} \
+%(subtarget_asm_float_spec) \
+%{mthumb-interwork:-mthumb-interwork} \
+%(subtarget_extra_asm_spec)"
+
+/* Because TARGET_DEFAULT sets ARM_FLAG_SOFT_FLOAT */
+#undef SUBTARGET_ASM_FLOAT_SPEC
+#define SUBTARGET_ASM_FLOAT_SPEC	\
+  "%{mhard-float: } \
+   %{mapcs-float:-mfloat } \
+   %{msoft-float:-mno-fpu} \
+   %{!mhard-float: \
+     %{!apcs-float: \
+       %{!msoft-float:-mno-fpu}}}"
+
+#undef SUBTARGET_EXTRA_SPECS
+#define SUBTARGET_EXTRA_SPECS				\
+  { "subtarget_extra_asm_spec", SUBTARGET_EXTRA_ASM_SPEC }, \
+  { "subtarget_asm_float_spec", SUBTARGET_ASM_FLOAT_SPEC },
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/arm/t-arm-elf gcc-3.3.3/gcc/config/arm/t-arm-elf
--- /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/arm/t-arm-elf	Wed May  8 10:01:13 2002
+++ gcc-3.3.3/gcc/config/arm/t-arm-elf	Thu Mar  4 07:21:28 2004
@@ -20,57 +20,57 @@
 	echo '#endif' >> dp-bit.c
 	cat $(srcdir)/config/fp-bit.c >> dp-bit.c
 
-	
+
 MULTILIB_OPTIONS     = marm/mthumb
 MULTILIB_DIRNAMES    = arm thumb
-MULTILIB_EXCEPTIONS  = 
-	
-# MULTILIB_OPTIONS     += mlittle-endian/mbig-endian
-# MULTILIB_DIRNAMES    += le be
-# MULTILIB_EXCEPTIONS  = 
-# MULTILIB_MATCHES     = mbig-endian=mbe mlittle-endian=mle
-# 
-# MULTILIB_OPTIONS    += mhard-float/msoft-float
-# MULTILIB_DIRNAMES   += fpu soft
-# MULTILIB_EXCEPTIONS += *mthumb/*mhard-float*
-# 
+MULTILIB_EXCEPTIONS  =
+
+MULTILIB_OPTIONS     += mlittle-endian/mbig-endian
+MULTILIB_DIRNAMES    += le be
+MULTILIB_EXCEPTIONS  =
+MULTILIB_MATCHES     = mbig-endian=mbe mlittle-endian=mle
+
+MULTILIB_OPTIONS    += mhard-float/msoft-float
+MULTILIB_DIRNAMES   += fpu soft
+MULTILIB_EXCEPTIONS += *mthumb/*mhard-float*
+
 # MULTILIB_OPTIONS    += mapcs-32/mapcs-26
 # MULTILIB_DIRNAMES   += 32bit 26bit
 # MULTILIB_EXCEPTIONS += *mthumb/*mapcs-26*
-# 
-# MULTILIB_OPTIONS    += mno-thumb-interwork/mthumb-interwork
-# MULTILIB_DIRNAMES   += normal interwork
-# MULTILIB_EXCEPTIONS += *mapcs-26/*mthumb-interwork*
-# 
+
+MULTILIB_OPTIONS    += mno-thumb-interwork/mthumb-interwork
+MULTILIB_DIRNAMES   += normal interwork
+MULTILIB_EXCEPTIONS += *mapcs-26/*mthumb-interwork*
+
 # MULTILIB_OPTIONS    += fno-leading-underscore/fleading-underscore
 # MULTILIB_DIRNAMES   += elf under
-# 
-# MULTILIB_OPTIONS    += mcpu=arm7
-# MULTILIB_DIRNAMES   += nofmult
-# MULTILIB_EXCEPTIONS += *mthumb*/*mcpu=arm7*
-# # Note: the multilib_exceptions matches both -mthumb and
-# # -mthumb-interwork
-# #
-# # We have to match all the arm cpu variants which do not have the
-# # multiply instruction and treat them as if the user had specified
-# # -mcpu=arm7.  Note that in the following the ? is interpreted as
-# # an = for the purposes of matching command line options.
-# # FIXME: There ought to be a better way to do this.
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7d
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7di
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm70
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm700
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm700i
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm710
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm710c
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7100
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7500
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7500fe
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm6
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm60
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm600
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm610
-# MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm620
+
+MULTILIB_OPTIONS    += mcpu=arm7
+MULTILIB_DIRNAMES   += nofmult
+MULTILIB_EXCEPTIONS += *mthumb*/*mcpu=arm7*
+# Note: the multilib_exceptions matches both -mthumb and
+# -mthumb-interwork
+#
+# We have to match all the arm cpu variants which do not have the
+# multiply instruction and treat them as if the user had specified
+# -mcpu=arm7.  Note that in the following the ? is interpreted as
+# an = for the purposes of matching command line options.
+# FIXME: There ought to be a better way to do this.
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7d
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7di
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm70
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm700
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm700i
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm710
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm710c
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7100
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7500
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7500fe
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm6
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm60
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm600
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm610
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm620
 
 EXTRA_MULTILIB_PARTS = crtbegin.o crtend.o crti.o crtn.o
 
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/arm/t-rtems gcc-3.3.3/gcc/config/arm/t-rtems
--- /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/arm/t-rtems	Wed Dec 31 18:00:00 1969
+++ gcc-3.3.3/gcc/config/arm/t-rtems	Thu Feb 26 08:06:25 2004
@@ -0,0 +1,4 @@
+MULTILIB_OPTIONS     = marm/mthumb msoft-float/mhard-float
+MULTILIB_DIRNAMES    = arm thumb soft fpu
+MULTILIB_EXCEPTIONS  = 
+MULTILIB_MATCHES = marm=mno-thumb
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/rtems.h gcc-3.3.3/gcc/config/rtems.h
--- /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/rtems.h	Fri Apr 19 13:43:11 2002
+++ gcc-3.3.3/gcc/config/rtems.h	Thu Mar 11 15:43:55 2004
@@ -35,3 +35,15 @@
 
 #undef ENDFILE_SPEC
 #define ENDFILE_SPEC   ""
+
+/*
+ * Some targets do not set up LIB_SPECS, override it, here.
+ */
+#define STD_LIB_SPEC "%{!shared:%{g*:-lg} %{!p:%{!pg:-lc}}%{p:-lc_p}%{pg:-lc_p}}"
+
+#undef LIB_SPEC
+#define LIB_SPEC "%{!qrtems: " STD_LIB_SPEC "} " \
+"%{!nostdlib: %{qrtems: --start-group \
+ %{!qrtems_debug: -lrtemsbsp -lrtemscpu} \
+ %{qrtems_debug: -lrtemsbsp_g -lrtemscpu_g} \
+ -lc -lgcc --end-group %{!qnolinkcmds: -T linkcmds%s}}}"
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/sparc/rtemself.h gcc-3.3.3/gcc/config/sparc/rtemself.h
--- /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config/sparc/rtemself.h	Fri Apr 12 08:35:02 2002
+++ gcc-3.3.3/gcc/config/sparc/rtemself.h	Thu Mar 11 15:47:20 2004
@@ -1,26 +1,225 @@
-/* Definitions for rtems targeting a SPARC using ELF.
-   Copyright (C) 1996, 1997, 2000, 2002 Free Software Foundation, Inc.
-   Contributed by Joel Sherrill (joel@OARcorp.com).
+/* Definitions for SPARC running RTEMS-based systems with ELF.
+   Copyright (C) 1996, 1997, 1998, 1999, 2000, 2002, 2003, 2004
+   Free Software Foundation, Inc.
+   Based upon config/sparc/linux.h by Eddie C. Dost (ecd@skynet.be)
+   Modified for RTEMS by Joel Sherrill (joel@gcc.gnu.org)
 
-This file is part of GNU CC.
+This file is part of GCC.
 
-GNU CC is free software; you can redistribute it and/or modify
+GCC is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2, or (at your option)
 any later version.
 
-GNU CC is distributed in the hope that it will be useful,
+GCC is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
-along with GNU CC; see the file COPYING.  If not, write to
+along with GCC; see the file COPYING.  If not, write to
 the Free Software Foundation, 59 Temple Place - Suite 330,
 Boston, MA 02111-1307, USA.  */
 
-/* Specify predefined symbols in preprocessor.  */
-
-#undef CPP_PREDEFINES
-#define CPP_PREDEFINES "-Dsparc -D__GCC_NEW_VARARGS__ -D__rtems__ \
-  -D__USE_INIT_FINI__ -Asystem=rtems"
+#define TARGET_OS_CPP_BUILTINS()		\
+  do						\
+    {						\
+	builtin_define_std ("sparc");		\
+	builtin_define ("__rtems__");		\
+	builtin_define ("__USE_INIT_FINI__");	\
+	builtin_assert ("system=rtems");	\
+    }						\
+  while (0)
+
+#undef  ENDFILE_SPEC
+#define ENDFILE_SPEC \
+  "%{ffast-math|funsafe-math-optimizations:crtfastmath.o%s} \
+   %{shared|pie:crtendS.o%s;:crtend.o%s} crtn.o%s"
+
+/* This is for -profile to use -lc_p instead of -lc.  */
+#undef	CC1_SPEC
+#define	CC1_SPEC "%{profile:-p} \
+%{sun4:} %{target:} \
+%{mcypress:-mcpu=cypress} \
+%{msparclite:-mcpu=sparclite} %{mf930:-mcpu=f930} %{mf934:-mcpu=f934} \
+%{mv8:-mcpu=v8} %{msupersparc:-mcpu=supersparc} \
+"
+
+/* The GNU C++ standard library requires that these macros be defined.  */
+#undef CPLUSPLUS_CPP_SPEC
+#define CPLUSPLUS_CPP_SPEC "-D_GNU_SOURCE %(cpp)"
+
+#undef TARGET_VERSION
+#define TARGET_VERSION fprintf (stderr, " (sparc GNU/Linux with ELF)");
+
+#undef SUBTARGET_SWITCHES
+#define SUBTARGET_SWITCHES \
+{"long-double-64", -MASK_LONG_DOUBLE_128, N_("Use 64 bit long doubles") }, \
+{"long-double-128", MASK_LONG_DOUBLE_128, N_("Use 128 bit long doubles") },
+
+#undef SIZE_TYPE
+#define SIZE_TYPE "unsigned int"
+ 
+#undef PTRDIFF_TYPE
+#define PTRDIFF_TYPE "int"
+  
+#undef WCHAR_TYPE
+#define WCHAR_TYPE "int"
+   
+#undef WCHAR_TYPE_SIZE
+#define WCHAR_TYPE_SIZE 32
+
+#undef CPP_SUBTARGET_SPEC
+#define CPP_SUBTARGET_SPEC ""
+
+/* just like sparc/elf.h */
+#undef LIB_SPEC
+#define LIB_SPEC ""
+
+/* just like sparc/elf.h */
+#undef LINK_SPEC 
+
+/* The sun bundled assembler doesn't accept -Yd, (and neither does gas).
+   It's safe to pass -s always, even if -g is not used.  */
+#undef ASM_SPEC
+#define ASM_SPEC \
+  "%{V} %{v:%{!V:-V}} %{!Qn:-Qy} %{n} %{T} %{Ym,*} %{Wa,*:%*} -s \
+   %{fpic|fPIC|fpie|fPIE:-K PIC} %(asm_cpu) %(asm_relax)"
+
+/* Same as sparc.h */
+#undef DBX_REGISTER_NUMBER
+#define DBX_REGISTER_NUMBER(REGNO) (REGNO)
+
+#undef ASM_OUTPUT_ALIGNED_LOCAL
+#define ASM_OUTPUT_ALIGNED_LOCAL(FILE, NAME, SIZE, ALIGN)		\
+do {									\
+  fputs ("\t.local\t", (FILE));		\
+  assemble_name ((FILE), (NAME));					\
+  putc ('\n', (FILE));							\
+  ASM_OUTPUT_ALIGNED_COMMON (FILE, NAME, SIZE, ALIGN);			\
+} while (0)
+
+#undef COMMON_ASM_OP
+#define COMMON_ASM_OP "\t.common\t"
+
+#undef  LOCAL_LABEL_PREFIX
+#define LOCAL_LABEL_PREFIX  "."
+
+/* This is how to output a reference to an internal numbered label where
+   PREFIX is the class of label and NUM is the number within the class.  */
+
+#undef  ASM_OUTPUT_INTERNAL_LABELREF
+#define ASM_OUTPUT_INTERNAL_LABELREF(FILE,PREFIX,NUM)	\
+  fprintf (FILE, ".L%s%d", PREFIX, NUM)
+
+/* This is how to store into the string LABEL
+   the symbol_ref name of an internal numbered label where
+   PREFIX is the class of label and NUM is the number within the class.
+   This is suitable for output with `assemble_name'.  */
+
+#undef  ASM_GENERATE_INTERNAL_LABEL
+#define ASM_GENERATE_INTERNAL_LABEL(LABEL,PREFIX,NUM)	\
+  sprintf (LABEL, "*.L%s%ld", PREFIX, (long)(NUM))
+
+
+/* Define for support of TFmode long double.
+   SPARC ABI says that long double is 4 words.  */
+#define LONG_DOUBLE_TYPE_SIZE (TARGET_LONG_DOUBLE_128 ? 128 : 64)
+
+/* Constant which presents upper bound of the above value.  */
+#define MAX_LONG_DOUBLE_TYPE_SIZE 128
+
+/* Define this to set long double type size to use in libgcc2.c, which can
+   not depend on target_flags.  */
+#ifdef __LONG_DOUBLE_128__
+#define LIBGCC2_LONG_DOUBLE_TYPE_SIZE 128
+#else
+#define LIBGCC2_LONG_DOUBLE_TYPE_SIZE 64
+#endif
+
+
+#ifdef HAVE_AS_TLS
+#undef TARGET_SUN_TLS
+#undef TARGET_GNU_TLS
+#define TARGET_SUN_TLS 0
+#define TARGET_GNU_TLS 1
+#endif
+
+/* Don't be different from other Linux platforms in this regard.  */
+#define HANDLE_PRAGMA_PACK_PUSH_POP
+
+/* We use GNU ld so undefine this so that attribute((init_priority)) works.  */
+#undef CTORS_SECTION_ASM_OP
+#undef DTORS_SECTION_ASM_OP
+
+#define TARGET_ASM_FILE_END file_end_indicate_exec_stack
+
+#define TARGET_HAS_F_SETLKW
+
+#undef LINK_GCC_C_SEQUENCE_SPEC
+#define LINK_GCC_C_SEQUENCE_SPEC \
+  "%{static:--start-group} %G %L %{static:--end-group}%{!static:%G}"
+
+/* Do code reading to identify a signal frame, and set the frame
+   state data appropriately.  See unwind-dw2.c for the structs.  */
+
+#define MD_FALLBACK_FRAME_STATE_FOR(CONTEXT, FS, SUCCESS)		\
+  do {									\
+    unsigned int *pc_ = (CONTEXT)->ra;					\
+    int new_cfa_, i_, oldstyle_;					\
+    int regs_off_, fpu_save_off_;					\
+    int fpu_save_, this_cfa_;						\
+									\
+    if (pc_[1] != 0x91d02010)		/* ta 0x10 */			\
+      break;								\
+    if (pc_[0] == 0x821020d8)		/* mov NR_sigreturn, %g1 */	\
+      oldstyle_ = 1;							\
+    else if (pc_[0] == 0x82102065)	/* mov NR_rt_sigreturn, %g1 */	\
+      oldstyle_ = 0;							\
+    else								\
+      break;								\
+    if (oldstyle_)							\
+      {									\
+        regs_off_ = 96;							\
+        fpu_save_off_ = regs_off_ + (4 * 4) + (16 * 4);			\
+      }									\
+    else								\
+      {									\
+        regs_off_ = 96 + 128;						\
+        fpu_save_off_ = regs_off_ + (4 * 4) + (16 * 4) + (2 * 4);	\
+      }									\
+    this_cfa_ = (int) (CONTEXT)->cfa;					\
+    new_cfa_ = *(int *)(((CONTEXT)->cfa) + (regs_off_+(4*4)+(14 * 4)));	\
+    fpu_save_ = *(int *)((this_cfa_) + (fpu_save_off_));		\
+    (FS)->cfa_how = CFA_REG_OFFSET;					\
+    (FS)->cfa_reg = 14;							\
+    (FS)->cfa_offset = new_cfa_ - (int) (CONTEXT)->cfa;			\
+    for (i_ = 1; i_ < 16; ++i_)						\
+      {									\
+        if (i_ == 14)							\
+          continue;							\
+	(FS)->regs.reg[i_].how = REG_SAVED_OFFSET;			\
+	(FS)->regs.reg[i_].loc.offset =					\
+	   this_cfa_ + (regs_off_+(4 * 4)+(i_ * 4)) - new_cfa_;		\
+      }									\
+    for (i_ = 0; i_ < 16; ++i_)						\
+      {									\
+	(FS)->regs.reg[i_ + 16].how = REG_SAVED_OFFSET;			\
+	(FS)->regs.reg[i_ + 16].loc.offset =				\
+	  this_cfa_ + (i_ * 4) - new_cfa_;				\
+      }									\
+    if (fpu_save_)							\
+      {									\
+	for (i_ = 0; i_ < 32; ++i_)					\
+	  {								\
+	    (FS)->regs.reg[i_ + 32].how = REG_SAVED_OFFSET;		\
+	    (FS)->regs.reg[i_ + 32].loc.offset =			\
+	      (fpu_save_ + (i_ * 4)) - new_cfa_;			\
+	  }								\
+      }									\
+    /* Stick return address into %g0, same trick Alpha uses.  */	\
+    (FS)->regs.reg[0].how = REG_SAVED_OFFSET;				\
+    (FS)->regs.reg[0].loc.offset = this_cfa_+(regs_off_+4)-new_cfa_;	\
+    (FS)->retaddr_column = 0;						\
+    goto SUCCESS;							\
+  } while (0)
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config.gcc gcc-3.3.3/gcc/config.gcc
--- /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/config.gcc	Wed Jan 21 00:06:00 2004
+++ gcc-3.3.3/gcc/config.gcc	Thu Mar 11 15:08:30 2004
@@ -1962,7 +1962,7 @@
 	  thread_file='rtems'
 	fi
 	;;
-mips*-*-rtems*)
+mips-*-rtems*)
 	xm_defines=POSIX
 	tm_file="${tm_file} mips/elf.h mips/rtems.h rtems.h"
 	tmake_file="mips/t-elf t-rtems mips/t-rtems"
@@ -1970,6 +1970,15 @@
 	  thread_file='rtems'
 	fi
 	;;
+mips64-*-rtems*)
+	tm_file="${tm_file} mips/elf64.h mips/rtems.h rtems.h"
+	tmake_file="mips/t-elf t-rtems mips/t-rtems"
+	target_cpu_default="MASK_64BIT|MASK_FLOAT64|MASK_GAS"
+	tm_defines="MIPS_ISA_DEFAULT=3 MIPS_ABI_DEFAULT=ABI_32"
+	if test x$enable_threads = xyes; then
+	  thread_file='rtems'
+	fi
+ 	;;
 mipstx39-*-elf* | mipstx39el-*-elf*)
 	tm_file="${tm_file} mips/r3900.h mips/elf.h"
 	tmake_file=mips/t-r3900
@@ -2456,7 +2465,7 @@
 	;;
 sparc-*-rtems*)
 	xm_defines=POSIX
-	tm_file="${tm_file} dbxelf.h elfos.h svr4.h sparc/sysv4.h sol2.h sparc/sol2.h sparc/elf.h sparc/rtemself.h rtems.h"
+	tm_file="${tm_file} dbxelf.h elfos.h svr4.h sparc/sysv4.h sparc/rtemself.h"
 	tmake_file="sparc/t-elf sparc/t-crtfm t-rtems"
 	extra_parts="crti.o crtn.o crtbegin.o crtend.o"
 	if test x$enable_threads = xyes; then
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/cppdefault.h gcc-3.3.3/gcc/cppdefault.h
--- /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/cppdefault.h	Thu Nov  6 17:13:31 2003
+++ gcc-3.3.3/gcc/cppdefault.h	Thu Feb 26 08:06:25 2004
@@ -38,6 +38,7 @@
 # undef LOCAL_INCLUDE_DIR
 # undef SYSTEM_INCLUDE_DIR
 # undef STANDARD_INCLUDE_DIR
+# undef PREFIX_INCLUDE_DIR
 #else
 # undef CROSS_INCLUDE_DIR
 #endif
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/gthr-rtems.h gcc-3.3.3/gcc/gthr-rtems.h
--- /usr1/rtems/work-tools/original/gcc-3.3.3/gcc/gthr-rtems.h	Wed Jan 29 09:05:37 2003
+++ gcc-3.3.3/gcc/gthr-rtems.h	Thu May  6 15:56:44 2004
@@ -37,7 +37,6 @@
 #define __GTHREADS 1
 
 #define __GTHREAD_ONCE_INIT  0
-#define __GTHREAD_MUTEX_INIT 0
 #define __GTHREAD_MUTEX_INIT_FUNCTION  rtems_gxx_mutex_init
 
 /* avoid depedency on rtems specific headers */
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/libffi/configure.in gcc-3.3.3/libffi/configure.in
--- /usr1/rtems/work-tools/original/gcc-3.3.3/libffi/configure.in	Sat Aug  9 01:59:00 2003
+++ gcc-3.3.3/libffi/configure.in	Thu Feb 26 08:06:25 2004
@@ -48,6 +48,7 @@
 case "$host" in
 mips-sgi-irix5.* | mips-sgi-irix6.*) TARGET=MIPS; TARGETDIR=mips;;
 i*86-*-linux*) TARGET=X86; TARGETDIR=x86;;
+i*86-*-rtems*) TARGET=X86; TARGETDIR=x86;;
 i*86-*-sco3.2v5*) TARGET=X86; TARGETDIR=x86;;
 i*86-*-solaris*) TARGET=X86; TARGETDIR=x86;;
 i*86-*-beos*) TARGET=X86; TARGETDIR=x86;;
@@ -59,22 +60,28 @@
 sparc-sun-4*) TARGET=SPARC; TARGETDIR=sparc;;
 sparc*-sun-*) TARGET=SPARC; TARGETDIR=sparc;;
 sparc-*-linux* | sparc-*-netbsdelf*) TARGET=SPARC; TARGETDIR=sparc;;
+sparc*-*-rtems*) TARGET=SPARC; TARGETDIR=sparc;;
 sparc64-*-linux* | sparc64-*-netbsd*) TARGET=SPARC; TARGETDIR=sparc;;
 alpha*-*-linux* | alpha*-*-osf* | alpha*-*-freebsd* | alpha*-*-netbsd*) TARGET=ALPHA; TARGETDIR=alpha;;
 ia64*-*-*) TARGET=IA64; TARGETDIR=ia64;;
 m68k-*-linux*) TARGET=M68K; TARGETDIR=m68k;;
+m68k-*-rtems*) TARGET=M68K; TARGETDIR=m68k;;
 mips64*-*);;
 mips*-*-linux*) TARGET=MIPS_LINUX; TARGETDIR=mips;;
+mips*-*-rtems*) TARGET=MIPS; TARGETDIR=mips;;
 powerpc-*-linux* | powerpc-*-sysv*) TARGET=POWERPC; TARGETDIR=powerpc;;
+powerpc-*-rtems*) TARGET=POWERPC; TARGETDIR=powerpc;;
 powerpc-*-beos*) TARGET=POWERPC; TARGETDIR=powerpc;;
 powerpc-*-darwin*) TARGET=POWERPC_DARWIN; TARGETDIR=powerpc;;
 powerpc-*-aix*) TARGET=POWERPC_AIX; TARGETDIR=powerpc;;
 rs6000-*-aix*) TARGET=POWERPC_AIX; TARGETDIR=powerpc;;
 arm*-*-linux-*) TARGET=ARM; TARGETDIR=arm;;
+arm*-*-rtems*) TARGET=ARM; TARGETDIR=arm ;;
 s390-*-linux-*) TARGET=S390; TARGETDIR=s390;;
 s390x-*-linux-*) TARGET=S390; TARGETDIR=s390;;
 x86_64-*-linux*) TARGET=X86_64; TARGETDIR=x86;;
 sh-*-linux* | sh[[34]]*-*-linux*) TARGET=SH; TARGETDIR=sh;;
+sh-*-rtems*) TARGET=SH; TARGETDIR=sh;;
 esac
 
 if test $TARGETDIR = unknown; then
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/libjava/configure.in gcc-3.3.3/libjava/configure.in
--- /usr1/rtems/work-tools/original/gcc-3.3.3/libjava/configure.in	Tue Jun 17 11:04:20 2003
+++ gcc-3.3.3/libjava/configure.in	Thu Feb 26 08:06:25 2004
@@ -358,6 +358,9 @@
 	;;
     esac
     ;;
+ rtems)
+    THREADS=posix
+    ;;
  win32)
     ;;
  decosf1 | irix | mach | os2 | solaris | dce | vxworks)
@@ -378,6 +381,9 @@
 case "$THREADS" in
  posix)
     case "$host" in
+     *-*-rtems*)
+	# Don't set THREADLIBS here.  RTEMS doesn't have -lpthread.
+	;;
      *-*-cygwin*)
 	# Don't set THREADLIBS here.  Cygwin doesn't have -lpthread.
 	;;
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/libstdc++-v3/include/bits/locale_facets.tcc gcc-3.3.3/libstdc++-v3/include/bits/locale_facets.tcc
--- /usr1/rtems/work-tools/original/gcc-3.3.3/libstdc++-v3/include/bits/locale_facets.tcc	Wed Jan 28 20:52:24 2004
+++ gcc-3.3.3/libstdc++-v3/include/bits/locale_facets.tcc	Thu Feb 26 08:06:25 2004
@@ -44,6 +44,8 @@
 #include <typeinfo>  		// For bad_cast.
 #include <bits/streambuf_iterator.h>
 
+extern "C" char *strdup(const char *);
+
 namespace std
 {
   template<typename _Facet>
diff -uNr /usr1/rtems/work-tools/original/gcc-3.3.3/u2dtmpf5JYMS gcc-3.3.3/u2dtmpf5JYMS
--- /usr1/rtems/work-tools/original/gcc-3.3.3/u2dtmpf5JYMS	Wed Dec 31 18:00:00 1969
+++ gcc-3.3.3/u2dtmpf5JYMS	Thu Mar  4 07:18:11 2004
@@ -0,0 +1,95 @@
+LIB1ASMSRC = arm/lib1funcs.asm
+LIB1ASMFUNCS = _udivsi3 _divsi3 _umodsi3 _modsi3 _dvmd_tls _bb_init_func _call_via_rX _interwork_call_via_rX
+
+# We want fine grained libraries, so use the new code to build the
+# floating point emulation libraries.
+FPBIT = fp-bit.c
+DPBIT = dp-bit.c
+
+fp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#define FLOAT' > fp-bit.c
+	echo '#ifndef __ARMEB__' >> fp-bit.c
+	echo '#define FLOAT_BIT_ORDER_MISMATCH' >> fp-bit.c
+	echo '#endif' >> fp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> fp-bit.c
+
+dp-bit.c: $(srcdir)/config/fp-bit.c
+	echo '#ifndef __ARMEB__' > dp-bit.c
+	echo '#define FLOAT_BIT_ORDER_MISMATCH' >> dp-bit.c
+	echo '#define FLOAT_WORD_ORDER_MISMATCH' >> dp-bit.c
+	echo '#endif' >> dp-bit.c
+	cat $(srcdir)/config/fp-bit.c >> dp-bit.c
+
+
+MULTILIB_OPTIONS     = marm/mthumb
+MULTILIB_DIRNAMES    = arm thumb
+MULTILIB_EXCEPTIONS  =
+
+MULTILIB_OPTIONS     += mlittle-endian/mbig-endian
+MULTILIB_DIRNAMES    += le be
+MULTILIB_EXCEPTIONS  =
+MULTILIB_MATCHES     = mbig-endian=mbe mlittle-endian=mle
+
+MULTILIB_OPTIONS    += mhard-float/msoft-float
+MULTILIB_DIRNAMES   += fpu soft
+MULTILIB_EXCEPTIONS += *mthumb/*mhard-float*
+
+# MULTILIB_OPTIONS    += mapcs-32/mapcs-26
+# MULTILIB_DIRNAMES   += 32bit 26bit
+# MULTILIB_EXCEPTIONS += *mthumb/*mapcs-26*
+
+MULTILIB_OPTIONS    += mno-thumb-interwork/mthumb-interwork
+MULTILIB_DIRNAMES   += normal interwork
+MULTILIB_EXCEPTIONS += *mapcs-26/*mthumb-interwork*
+
+# MULTILIB_OPTIONS    += fno-leading-underscore/fleading-underscore
+# MULTILIB_DIRNAMES   += elf under
+
+MULTILIB_OPTIONS    += mcpu=arm7
+MULTILIB_DIRNAMES   += nofmult
+MULTILIB_EXCEPTIONS += *mthumb*/*mcpu=arm7*
+# Note: the multilib_exceptions matches both -mthumb and
+# -mthumb-interwork
+#
+# We have to match all the arm cpu variants which do not have the
+# multiply instruction and treat them as if the user had specified
+# -mcpu=arm7.  Note that in the following the ? is interpreted as
+# an = for the purposes of matching command line options.
+# FIXME: There ought to be a better way to do this.
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7d
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7di
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm70
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm700
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm700i
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm710
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm710c
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7100
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7500
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm7500fe
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm6
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm60
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm600
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm610
+MULTILIB_MATCHES    += mcpu?arm7=mcpu?arm620
+
+EXTRA_MULTILIB_PARTS = crtbegin.o crtend.o crti.o crtn.o
+
+# If EXTRA_MULTILIB_PARTS is not defined above then define EXTRA_PARTS here
+# EXTRA_PARTS = crtbegin.o crtend.o crti.o crtn.o
+
+LIBGCC = stmp-multilib
+INSTALL_LIBGCC = install-multilib
+
+# Currently there is a bug somewhere in GCC's alias analysis
+# or scheduling code that is breaking _fpmul_parts in fp-bit.c.
+# Disabling function inlining is a workaround for this problem.
+TARGET_LIBGCC2_CFLAGS = -Dinhibit_libc -fno-inline
+
+# Assemble startup files.
+$(T)crti.o: $(srcdir)/config/arm/crti.asm $(GCC_PASSES)
+	$(GCC_FOR_TARGET) $(GCC_CFLAGS) $(MULTILIB_CFLAGS) $(INCLUDES) \
+	-c -o $(T)crti.o -x assembler-with-cpp $(srcdir)/config/arm/crti.asm
+
+$(T)crtn.o: $(srcdir)/config/arm/crtn.asm $(GCC_PASSES)
+	$(GCC_FOR_TARGET) $(GCC_CFLAGS) $(MULTILIB_CFLAGS) $(INCLUDES) \
+	-c -o $(T)crtn.o -x assembler-with-cpp $(srcdir)/config/arm/crtn.asm
